SystemOrganization addCategory: #Ranking!

Object subclass: #Ranking
	instanceVariableNames: 'attenders sortDescriptor sortedRanks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!Ranking methodsFor: 'changing' stamp: 'HwaJong 9/11/2013 14:40'!
attenders: anArray 
	attenders := anArray.
	self sortedRanks: nil! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/14/2013 19:53'!
attendersOfRankOrder: anInteger 
	^(self sortedRanks select: [:each| each rankOrder = anInteger ]) collect: [:each| each attender] ! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 9/11/2013 14:38'!
defaultSortedRanks

	|sortedAttender sortedRanks rank|
	attenders isEmpty ifTrue: [^{}].
	sortedAttender := attenders asSortedCollection: sortDescriptor.
	sortedRanks := sortedAttender collect: [:each| RankingEntry new ranking: self; attender: each ].
	
	rank := 1.
	sortedRanks first rankOrder: 1.

	2 to: sortedRanks size do: [:index|
		|prior unrankedYet|
		prior := sortedRanks at: index-1.
		unrankedYet := sortedRanks at: index.
		sortDescriptor
			object1: (prior attender) 
			object2: (unrankedYet attender) 
			ifSame: [unrankedYet rankOrder: prior rankOrder]
			ifInOrder: [unrankedYet rankOrder: index]
			ifNotInOrder: [unrankedYet rankOrder: index]].
	^sortedRanks ! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/6/2014 19:06'!
rankOrderOfAttender: anObject
	^self sortedRanks 
		detect: [:sr|sr attender = anObject]
		ifFound: [:found| found rankOrder ]
		ifNone: [self error: 'failed to find attender']! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 8/6/2013 14:20'!
sortDescriptor
	^ sortDescriptor! !

!Ranking methodsFor: 'changing' stamp: 'HwaJong 9/11/2013 14:40'!
sortDescriptor: anSortDescriptor 
	sortDescriptor := anSortDescriptor.
	self sortedRanks: nil.! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 9/11/2013 14:39'!
sortedRanks

	^sortedRanks setDefault: #defaultSortedRanks for: self withSetter: #sortedRanks:! !

!Ranking methodsFor: 'changing' stamp: 'HwaJong 9/11/2013 14:39'!
sortedRanks: aSequenceableCollection

	sortedRanks := aSequenceableCollection! !

Object subclass: #RankingEntry
	instanceVariableNames: 'rankOrder attender ranking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!RankingEntry methodsFor: 'answering' stamp: 'HwaJong 2/16/2013 12:13'!
attender
	^ attender! !

!RankingEntry methodsFor: 'changing' stamp: 'HwaJong 2/16/2013 12:10'!
attender: anObject
	attender := anObject 
	! !

!RankingEntry methodsFor: 'doing' stamp: 'HwaJong 8/6/2013 14:26'!
printOn: stream

	stream print: rankOrder.
	stream nextPutAll: ') '.
	ranking ifNotNil: 
		[
			(ranking sortDescriptor respondsTo: #aspect)
				ifTrue: [stream print: (self rankValue). stream space.]
		].
	stream print: attender.! !

!RankingEntry methodsFor: 'answering' stamp: 'HwaJong 2/16/2013 12:38'!
rankOrder
	^ rankOrder! !

!RankingEntry methodsFor: 'changing' stamp: 'HwaJong 2/16/2013 12:10'!
rankOrder: anInteger 
	rankOrder := anInteger! !

!RankingEntry methodsFor: 'answering' stamp: 'HwaJong 8/6/2013 14:27'!
rankValue
	^ranking sortDescriptor aspect value: attender! !

!RankingEntry methodsFor: 'changing' stamp: 'HwaJong 8/6/2013 14:15'!
ranking: aRanking 
	ranking := aRanking ! !

TestCase subclass: #RankingTest
	instanceVariableNames: 'ranking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
setUp
	super setUp.
	ranking := Ranking new.
	ranking attenders: #(1 2 3 1 2 3 1 2).
	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
test12312312
	self assert: ((ranking sortedRanks collect: [:each| {each rankOrder. each attender} ]) asArray)
	equals: #((1 3) (1 3) (3 2) (3 2) (3 2) (6 1) (6 1) (6 1))! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRank1
	self assert: ((ranking attendersOfRankOrder: 1) asArray)
	equals: #(3 3)! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRank2
	self assert: ((ranking attendersOfRankOrder: 2) asArray)
	equals: #()! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRank3
	self assert: ((ranking attendersOfRankOrder: 3) asArray)
	equals: #(2 2 2)! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRankOfAttender
	self assert: (ranking rankOrderOfAttender: 1) equals: 6! !
